<template>
	<div class="row d-flex align-items-center">
		<div class="col-6">
			<h3>
				Отделы
			</h3>
		</div>
		<div class="col-6 d-flex justify-content-end">
			<a-tooltip placement="top" >
		        <template slot="title">
		          <span>Добавить отдел</span>
		        </template>
		        <a-button type="primary" shape="circle" icon="plus" @click="showModal"></a-button>
		    </a-tooltip>
		</div>
		<div class="col-12 mt-3">
			<div class="mb-3" v-for="department in departments" :key="department.id">
				<a-card>
					<div class="row">
						<div class="col-9">
							<strong>
								{{ department.name }}
							</strong>
							<p>
								Создан: {{ department.created_at }}<br>
								Обновлен: {{ department.updated_at}}<br>
								Всего сотрудников: {{ department.users.length }}
							</p>
						</div>
						<div class="col-3 d-flex justify-content-end">
							<a-button-group>
						      <a-button type="primary" icon="edit" />
						      <a-button @click="deleteDepartment(department.id, department.users.length)" type="danger" icon="delete" />
						    </a-button-group>
						</div>
					</div>
				</a-card>
			</div>
		</div>
		<a-modal
	      v-model="visible"
	      title="Добавить отдел"
	      onOk="handleOk"
	    >
	      <template slot="footer">
	        <a-button key="back" @click="handleCancel">Отмена</a-button>
	        <a-button key="submit" type="primary" :loading="loading" @click="handleOk">
	          Отправить
	        </a-button>
	      </template>
	      <form>
	      	<div class="form-group">
	      		<a-input placeholder="Название" v-model="add.name"/>
	      	</div>
	      	<div class="form-group">
	      		<a-textarea placeholder="Описание" :autosize="{ minRows: 6, maxRows: 30 }" v-model="add.description"/>
	      	</div>
	      </form>
	    </a-modal>
	</div>
</template>

<script type="text/javascript">
	export default {
		data() {
			return {
				departments: '',
				loading: false,
      			visible: false,
      			add: {
      				name: '',
      				description: ''
      			}
			}
		},
		created() {
			this.loadData()
		},
		methods: {
			loadData() {
				this.$http.get('/api/v1/getAllDepartments')
				.then(this.loadDataSuccess,this.loadDataError)
			},
			loadDataSuccess(res) {
				this.departments = res.body
			},
			loadDataError(err) {

			},
			showModal() {
		      this.visible = true;
		    },
		    handleOk(e) {
		      this.loading = true;
		      this.addDepartment()
		    },
		    handleCancel(e) {
		      this.visible = false;
		    },
		    addDepartment() {
		    	let params = {
		    		name: this.add.name,
		    		description: this.add.description
		    	}
		    	this.$http.post('/api/v1/addDepartment', params)
		    	.then(this.addDepartmentSuccess,this.addDepartmentError)
		    },
		    addDepartmentSuccess(res) {
		    	this.$message.success('Отдел добавлен');
		    	this.loadData()
		    	this.add.name = ''
		    	this.add.description = ''
		    	this.visible = false
		    	this.loading = false
		    },
		    addDepartmentError(err) {
		    	if (err.status === 422) {
		    		this.loading = false
		    		this.$message.error('Этот отдел уже существует');
		    	}
		    },
		    deleteDepartment(id, count) {
		    	if (count > 0) {
		    		this.$notification['error']({
			          message: 'Ошибка',
			          description: 'Нельзя удалить отдел с сотрудниками!',
			        });
		    	}
		    }
		}
	}
</script>